function [xlpp] = sol2lpp(xsol)
% SOL2LPP   Converting LIPSOL output to a solution of LPP model.
%           XLPP = SOL2LPP(XSOL) converts a LIPSOL solution XSOL
%           to XLPP -- a solution to the original LPP model.

% Yin Zhang, July 1995, Dept Math/Stat, UMBC
global variables

if nargin == 0 load solution; end;
if length(xsol) ~= size(variables,1)
   error('Sizes mismatch. Same name used in 2 formats?');
end

vxlpp = str2mat('Solution to the LPP model:'); xlpp = [];
for i = 1:length(xsol)
   varname = deblank(variables(i,:));
   if ~strcmp(varname,'$slack')
     vxlpp = str2mat(vxlpp,['  ' varname ' = ' num2str(xsol(i))]);
     xlpp = [xlpp; xsol(i)];
   end
end
vxlpp = str2mat(vxlpp,'stored in xlpp.');
fprintf('\n'); disp(vxlpp); fprintf('\n');
