C***********************************************************************
C
C   Version:        Beta-2.2
C   Last modified:  January 13, 1995
C   Author:         Yin Zhang
C                   Department of Mathematics and Statistics
C                   University of Maryland Baltimore County
C
C				  modified March, 2003, G. Sweriduk
C
C***********************************************************************
C
C Usage: [status] = mps2mat(path)
C
      SUBROUTINE MEXFUNCTION(NLHS, PLHS, NRHS, PRHS)
      INTEGER PLHS(*), PRHS(*)
      INTEGER NLHS, NRHS
C
      INTEGER MXCALLOC, MXGETPR
      INTEGER MXGETM, MXGETN
C
C KEEP THE ABOVE SUBROUTINE, ARGUMENT, AND FUNCTION DECLARATIONS 
C FOR USE IN ALL YOUR FORTRAN MEX FILES.
C---------------------------------------------------------------------
C
	INTEGER*4 MXCREATESTRING, MXGETSTRING, STATUS, STRLEN, PSTAT
	CHARACTER*100 INPUT_BUF, OUTPUT_BUF
C
C
C CHECK FOR PROPER NUMBER OF ARGUMENTS
C
      IF (NRHS .NE. 1) THEN
        CALL MEXERRMSGTXT('mps2mat requires 1 input arguments')
      ELSEIF (NLHS .NE. 1) THEN
        CALL MEXERRMSGTXT('mps2mat requires 1 output argument')
      ENDIF
C
C SPECIFY THE DIMENSIION OF WORKING VECTORS
C
      STRLEN  = MXGETM(PRHS(1))*MXGETN(PRHS(1))
C
C INITIALIZE INPUT STRING TO BLANK
C
	INPUT_BUF = ' '
C
C DEREFERENCE ARGUMENTS TO GET ARRAY POINTERS
C
      STATUS   = MXGETSTRING(PRHS(1),INPUT_BUF,100)
	IF (STATUS .NE. 0) THEN
		CALL MEXERRMSGTXT('path length must be less than 100')
	ENDIF

C
C INITIALIZE OUTPUT STRING TO BLANK
C
	OUTPUT_BUF = ' '
C
C DO THE ACTUAL COMPUTATIONS IN A FORTRAN SUBROUTINE
C
      call mps2mat(INPUT_BUF,STRLEN,STATUS)
	IF (STATUS .EQ. 0) CALL MEXPRINTF('STATUS = 0')
	IF (STATUS .NE. 0) CALL MEXPRINTF('STATUS NONZERO')

C
C
C CREATE OUTPUT PARAMETER
C
      PLHS(1) = MXCREATEFULL(1, 1, 0)
      PSTAT    = MXGETPR(PLHS(1))
C
C Copy solution to output vector
C
C
	CALL MXCOPYINTEGER4TOPTR(STATUS,PSTAT,1)

      RETURN
      END


c----------------------------------------------------------------
c Convert from type real*8 in Matlab to type integer in Fortran
c----------------------------------------------------------------
      subroutine convertin(neqns, maxsub, nsuper,
     &           mxlnz, mxsuper, 
     &            xlnz,  xsuper, 
     &           mxlindx,mlindx,
     &            xlindx, lindx)

      integer neqns, maxsub, nsuper, i
      real*8  mxlnz(neqns+1), mxsuper(nsuper+1)
      integer  xlnz(neqns+1),  xsuper(nsuper+1)
      real*8  mxlindx(nsuper+1),mlindx(maxsub)
      integer  xlindx(nsuper+1), lindx(maxsub)


      do 10 i = 1, neqns + 1
         xlnz(i)   = mxlnz(i)
 10   continue

      do 20 i = 1, nsuper + 1
         xsuper(i) = mxsuper(i)
         xlindx(i) = mxlindx(i)
 20   continue

      do 30 i = 1, maxsub
         lindx(i) = mlindx(i)
 30   continue
      return
      end


c----------------------------------------------------------------
c Copy solution to output vector
c----------------------------------------------------------------
      subroutine copysol(neqns, rhs, sol)
      real*8 rhs(neqns), sol(neqns)
      integer i

      do 10 i = 1, neqns
         sol(i) = rhs(i)
 10   continue
      return
      end
